class AR_Keyboard
 {
  private:

   ALLEGRO_EVENT_QUEUE *event_queue;
   ALLEGRO_EVENT        event;
   bool KEY_DOWN[ALLEGRO_KEY_MAX];
   bool KEY_UP[ALLEGRO_KEY_MAX];
   bool KEY_PRESSED[ALLEGRO_KEY_MAX];

   void resetDownKeys()
    {
     for(int i=0;i<ALLEGRO_KEY_MAX;i++) KEY_DOWN[i] = false;
	}

   void resetUpKeys()
    {
     for(int i=0;i<ALLEGRO_KEY_MAX;i++) KEY_UP[i] = false;
	}

   void resetPressedKeys()
    {
     for(int i=0;i<ALLEGRO_KEY_MAX;i++) KEY_PRESSED[i] = false;
	}

  public:

   AR_Keyboard()
    {
     event_queue = al_create_event_queue();
     al_register_event_source(event_queue,al_get_keyboard_event_source());
     resetDownKeys();
     resetUpKeys();
     resetPressedKeys();
	}

   ~AR_Keyboard() { }

   bool keyDown(int key)    { return KEY_DOWN[key];    }
   
   bool keyUp(int key)      { return KEY_UP[key];      }
   
   bool keyPressed(int key) { return KEY_PRESSED[key]; }

   void clearKeys()
    {
     resetDownKeys();
     resetUpKeys();
     resetPressedKeys();
	}

   void getEvent()
    {
     resetDownKeys();
     resetUpKeys();
	 if(!al_is_event_queue_empty(event_queue))
      {
	   al_wait_for_event(event_queue,&event);
	   if(event.type == ALLEGRO_EVENT_KEY_DOWN) { KEY_DOWN[event.keyboard.keycode] = true; KEY_PRESSED[event.keyboard.keycode] = true;  }
	   if(event.type == ALLEGRO_EVENT_KEY_UP)   { KEY_UP[event.keyboard.keycode]   = true; KEY_PRESSED[event.keyboard.keycode] = false; }
      }
    }

 };
