class Item
 {
  private:

   int clicks,start_clicks,max_clicks;
   int cost,icon_frame;
   int percentage;
   bool enable_percentage;
   string name;
   string description[11];

  public:

   Item(string name, int cost, int icon_frame)
    {
	 this->name       = name;
	 this->cost       = cost;
	 this->icon_frame = icon_frame;
	 reset();
	}

   ~Item() { }

  void reset()
   {
	clicks     = start_clicks = 0;
	max_clicks = 10;
	percentage = 10;
	enable_percentage = true;
	// Item description before first click
	description[0]  = "";
	description[1]  = "";
	description[2]  = "";
	// Item description after first click
    description[3]  = "";
    description[4]  = "";
    description[5]  = "";
	// Item description at maximum
    description[6]  = "";
    description[7]  = "";
    description[8]  = "";
    // Full item description
    description[9]  = "";
    description[10] = "";
   }

  void click() { if(clicks <= max_clicks) clicks++; }

  void setDescription(int n, string str)           { description[n] = str;                        }
  
  void setPercentage(int percentage)               { this->percentage = percentage;               }
  
  void setEnablePercentage(bool enable_percentage) { this->enable_percentage = enable_percentage; }
  
  void setClicks(int clicks)                       { this->clicks = clicks; }
  
  void setMaxClicks(int max_clicks)                { this->max_clicks = max_clicks; }

  int getClicks()    { return clicks;                        }
  
  int getMaxClicks() { return max_clicks;                    }
  
  string getName()   { return name;                          }

  int getCost()      { return cost + (clicks * (cost >> 1)); }

  int getIconFrame() { return icon_frame;                    }

  string getPercentageString()
   {
    stringstream buffer;

    if(!enable_percentage) return "";
    if(clicks == 0 || clicks > max_clicks) return "";
    buffer.str(""); buffer << clicks * percentage << "%";
	return buffer.str();
   }

  string getDescription(int n)
   {
	if(n > 8)       return description[n];
	if(clicks == 0) return description[n];
	else            {
		             if(clicks <= max_clicks) return description[n + 3];
		             else                     return description[n + 6];
				    }
   }

 };
