class Player : public Object
 {
  private:

   AR_Game     *parent;
   AR_Keyboard *keyboard;
   AR_Sample   *sample_hit,***sample_cannons;
   int *score,*remaining_enemies;
   int bullets_hit;
   int max_health;
   int *inventory;
   int cargo,max_cargo,decay_step,decay_count;
   float radar_range;
   bool scan_enemies_remaining,scan_enemies_health,scan_enemies_shields;
   bool radar_enable;
   AR_ParticleGenerator *exhaust,*smoke,*explosion;
   Weapon **weapons;
   Item   **items;
   Object **hunters;
   Object **armadillos;
   Object **bandits;
   Object **cruisers;
   MissileLauncher *missile_launcher;

   void collisions()
    {
     // Collisions with all enemies bullets

     // Hunters
     for(int k=0;k<N_HUNTERS;k++)
      if(hunters[k]->getEnable())
       for(int n=0;n<hunters[k]->getTotalCannons();n++)
        {
         bullets = hunters[k]->getCannon(n)->getBulletsP();
         for(int i=0;i<hunters[k]->getTotalBullets(n);i++)
          {
	       if(bullets[i]->getAction() != AR::NONE)
	        {
			 if(shield->getHealth() > 0)
              if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
               { bullets[i]->hit(); shield->hit(bullets[i]); } //explosion->setAcceleration(0,0); explosion->start(bullets[i]->getX(),bullets[i]->getY(),1,1);
             if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Player
	          { bullets[i]->hit(); hit(bullets[i]); }
		    }
	      }
		}

     // Armadillos
     for(int k=0;k<N_ARMADILLOS;k++)
      if(armadillos[k]->getEnable())
       for(int n=0;n<armadillos[k]->getTotalCannons();n++)
        {
         bullets = armadillos[k]->getCannon(n)->getBulletsP();
         for(int i=0;i<armadillos[k]->getTotalBullets(n);i++)
          {
	       if(bullets[i]->getAction() != AR::NONE)
	        {
			 if(shield->getHealth() > 0)
              if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
               { bullets[i]->hit(); shield->hit(bullets[i]); }
             if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Player
	          { bullets[i]->hit(); hit(bullets[i]); }
		    }
	      }
		}

     // Bandits
     for(int k=0;k<N_BANDITS;k++)
      if(bandits[k]->getEnable())
       for(int n=0;n<bandits[k]->getTotalCannons();n++)
        {
         bullets = bandits[k]->getCannon(n)->getBulletsP();
         for(int i=0;i<bandits[k]->getTotalBullets(n);i++)
          {
	       if(bullets[i]->getAction() != AR::NONE)
	        {
			 if(shield->getHealth() > 0)
              if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
               { bullets[i]->hit(); shield->hit(bullets[i]); }
             if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Player
	          { bullets[i]->hit(); hit(bullets[i]); }
		    }
	      }
		}

     // Cruisers
     for(int k=0;k<N_CRUISERS;k++)
      if(cruisers[k]->getEnable())
       for(int n=0;n<cruisers[k]->getTotalCannons();n++)
        {
         bullets = cruisers[k]->getCannon(n)->getBulletsP();
         for(int i=0;i<cruisers[k]->getTotalBullets(n);i++)
          {
	       if(bullets[i]->getAction() != AR::NONE)
	        {
			 if(shield->getHealth() > 0)
              if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
               { bullets[i]->hit(); shield->hit(bullets[i]); }
             if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Player
	          { bullets[i]->hit(); hit(bullets[i]); }
		    }
	      }
		}
	}

  public:

   Player(string filename, AR_Display *display, AR_Game *parent, AR_Sprite *p_particles, AR_Sprite *p_cannons, AR_Sprite *p_shield, AR_Sprite *p_lights, AR_Sample **p_samples) : Object(filename,display,p_particles,p_cannons,p_shield,p_lights,NULL,2,3,AR::STATIC_COLLISION_MASK)
    {
	 score             = NULL;
	 remaining_enemies = NULL;
	 sample_hit        = NULL;
	 this->parent = parent;
	 keyboard  = parent->getKeyboard();
     exhaust   = generators[0];
     smoke     = generators[1];
     explosion = generators[2];
     inventory = (int *)malloc(sizeof(int)*N_INVENTORY);
     weapons   = (Weapon **)malloc(sizeof(Weapon *)*N_WEAPONS);
     weapons[AR::CANNON_BASIC]  = new Weapon("BASIC CANNON",   500, 200,  9, 1,  5.0, 1);
     weapons[AR::CANNON_FAST]   = new Weapon("FAST CANNON",   2000, 400,  9, 2,  9.0, 2);
     weapons[AR::CANNON_LASER]  = new Weapon("LASER CANNON",  6000, 600,  8, 2,  9.5, 3);
     weapons[AR::CANNON_TRIPLE] = new Weapon("TRIPLE CANNON", 7000, 450,  9, 3,  9.0, 4);
     weapons[AR::CANNON_PLASMA] = new Weapon("PLASMA CANNON",10000,1400, 11, 1, 10.0, 5);
     weapons[AR::CANNON_FLAME]  = new Weapon("FLAME  CANNON",15000,3600, 10, 1,  4.4, 6);
     weapons[AR::CANNON_SHELL]  = new Weapon("SHELL CANNON", 12000, 400,  9, 5,  8.6, 7);
     items = (Item **)malloc(sizeof(Item *)*N_ITEMS);
     items[AR::ITEM_RADAR]         = new Item("RADAR",           500,  8);
     items[AR::ITEM_SHIELD]        = new Item("SHIELDS",        2000,  9);
     items[AR::ITEM_HULL]          = new Item("HULL",           2000, 10);
     items[AR::ITEM_TARGETTING]    = new Item("TARGETTING",     2000, 11);
     items[AR::ITEM_CARGO]         = new Item("CARGO CAPACITY", 1000, 12);
     items[AR::ITEM_ENEMIES_SCAN]  = new Item("ENEMIES SCAN",   2000, 13);
     items[AR::ITEM_REPAIR_HULL]   = new Item("REPAIR HULL",    1500, 14);
     items[AR::ITEM_REPAIR_SHIELD] = new Item("REPAIR SHIELDS", 1000, 15);
     items[AR::ITEM_CANNON_ROTATE] = new Item("CANNON ROTATE",   500, 16);
     items[AR::ITEM_MISSILE]       = new Item("MISSILE LAUNCHER",8000, 17);
     missile_launcher = new MissileLauncher("",display,10,p_cannons);
     setSamplesP(p_samples);
	 reset();
	}

   ~Player() { }

   void run()
    {
	 Object::run();

     if(health > 0)
      {
	   if(keyboard->keyPressed(parent->getKeyLeft()))  { for(int i=0;i<total_cannons;i++) cannons[i]->rotateLeft();  }
	   if(keyboard->keyPressed(parent->getKeyRight())) { for(int i=0;i<total_cannons;i++) cannons[i]->rotateRight(); }
	   if(keyboard->keyPressed(parent->getKeyFire1())) cannons[0]->shoot();
	   if(keyboard->keyPressed(parent->getKeyFire2())) cannons[1]->shoot();
	   if(keyboard->keyPressed(parent->getKeyFire3())) { missile_launcher->shoot(armadillos[0]->getXP(),armadillos[0]->getYP()); }//TODO seledtTarget()
       collisions();
      }
     if(health <  400) smoke->start(x+AR_Util::random(80) - 40,y,health + 1);//TODO...
     if(health >= 200) { current_frame = 1; cannons[1]->setHullFrame(3); }
     if(health < 200)  { current_frame = 2; cannons[1]->setHullFrame(4); }
     if(health < 100)  { current_frame = 3; cannons[1]->setHullFrame(5); }
     if(health ==  0)  life--;

	 if(cargo > max_cargo * 0.1) // Save minimum 10% of cargo
	  {
	   decay_count--;
	   if(decay_count == 0) { decay_count = decay_step; cargo--; }
      }
     missile_launcher->run();

/*explosion->setStartSpeed(100,100);
explosion->setParticleATime(50);
explosion->setCurrentFrame(5);
explosion->setAcceleration(0.0001,0.0001); if(AR_Util::random(2)==1) { explosion->start(x,y,1,1); health--; }
explosion->setSource(x,y+AR_Util::random(6)-3);*/
     //smoke->setSource(x,y);
   	}

   void draw()
    {
	 if(!enable) return;
	 exhaust->draw();
	 Object::draw();
     for(int i=0;i<total_cannons;i++) cannons[i]->draw();
     missile_launcher->draw();
	 explosion->draw();
	 smoke->draw();
     shield->draw();
     for(int i=0;i<total_lights;i++) lights[i]->draw();
	}

   void hit(Bullet *b)
    {
	 Object::hit(b);
     smoke->setGenerateTime(health*4);
     explosion->setAcceleration(getAccelerationX(),getAccelerationY());
     explosion->start(b->getX(),b->getY(),1,1);
     lights[0]->setX(b->getX()); lights[0]->setY(b->getY()); lights[0]->startFlash();
     sample_hit->play();
	}

   void changeWeapon(int w, int c)
    {
	 // Change weapon to cannon c
	 int aux;

     cannons[c]->setWeapon(w);
     if(w != AR::NO_CANNON)
	  {
       aux = display->getMaxFPS() * 60; // Frames in a minute

	   // Cannon bullets related parameters
       cannons[c]->setBulletFrame(weapons[w]->getBulletFrame());
       cannons[c]->setBulletDamage(weapons[w]->getBulletDamage());
       cannons[c]->setReloadTime (aux/weapons[w]->getFirerate());
       cannons[c]->setPower(weapons[w]->getPower());
       // vecchi valori (per adesso uso questi)
	   cannons[0]->setFriction(0.003,0.003); cannons[1]->setFriction(0.003,0.003);
       cannons[0]->setLife(140);             cannons[1]->setLife(150);
       // Cannon shoot sound
       cannons[c]->setSampleShoot(sample_cannons[c][w]);	 
	  }
	}

   void reset()
    {
	 AR_Sprite::reset();
	 move_action = AR::NONE;
	 life = 240;
	 bullets_hit = 0;
	 cargo = max_cargo = 1000;
	 decay_step = 5;
	 decay_count = decay_step;
	 health      = max_health = 500;
	 radar_range = 1;
	 scan_enemies_remaining = scan_enemies_health = scan_enemies_shields = false;
	 radar_enable = false;
     setCenterX(width>>1); setCenterY(height>>1);
     setX(915);            setY(574);
     setCurrentFrame(1);
     shield->reset();

     for(int i=0;i<N_WEAPONS;i++) weapons[i]->reset();
     weapons[AR::CANNON_BASIC]->setDescription(0,"BASIC CHEAP CANNON, SHORT");
     weapons[AR::CANNON_BASIC]->setDescription(1,"RANGE AND VERY LOW POWER");
     weapons[AR::CANNON_FAST] ->setDescription(0,"FAST CANNON WITH A GOOD");
     weapons[AR::CANNON_FAST] ->setDescription(1,"RANGE");
     weapons[AR::CANNON_LASER]->setDescription(0,"LASER CANNON VERY FAST");
     weapons[AR::CANNON_LASER]->setDescription(1,"AND GOOD POWER");

     for(int i=0;i<N_ITEMS;i++) items[i]->reset();
     items[AR::ITEM_RADAR]->setDescription(0, "ACTIVATE RADAR");
     items[AR::ITEM_RADAR]->setDescription(3, "INCREASE RADAR");
     items[AR::ITEM_RADAR]->setDescription(4, "RANGE +");
     items[AR::ITEM_RADAR]->setDescription(6, "MAXIMUM RANGE");
     items[AR::ITEM_RADAR]->setDescription(7, "REACHED!");
     items[AR::ITEM_RADAR]->setDescription(9, "SHOW ENEMIES POSITION");
     items[AR::ITEM_RADAR]->setDescription(10,"TO PREVENT ATTACKS");

     items[AR::ITEM_SHIELD]->setDescription(0, "ACTIVATE SHIELDS");
     items[AR::ITEM_SHIELD]->setDescription(1, "PROTECTION");
     items[AR::ITEM_SHIELD]->setDescription(3, "RESTORE 100% POWER");
     items[AR::ITEM_SHIELD]->setDescription(4, "SHIELDS ENERGY +");
     items[AR::ITEM_SHIELD]->setDescription(5, "RECHARGE SPEED +1/MIN.");
     items[AR::ITEM_SHIELD]->setDescription(6, "MAXIMUM REACHED!");
     items[AR::ITEM_SHIELD]->setDescription(9, "SHILDS PROTECT THE BASE");
     items[AR::ITEM_SHIELD]->setDescription(10,"FROM ENEMIES FIRE");
     items[AR::ITEM_SHIELD]->setMaxClicks(9);

     items[AR::ITEM_HULL]->setDescription(3, "DAMAGE 100% REPAIRED");
     items[AR::ITEM_HULL]->setDescription(4, "HULL ARMOUR +");
     items[AR::ITEM_HULL]->setDescription(6, "MAXIMUM REACHED!");
     items[AR::ITEM_HULL]->setDescription(9, "INCREASE HULL ARMOUR AND");
     items[AR::ITEM_HULL]->setDescription(10,"REPAIR ALL HULL DAMAGE");
     items[AR::ITEM_HULL]->setClicks(1);

     items[AR::ITEM_TARGETTING]->setDescription(0, "ACTIVATE TARGETTING");
     items[AR::ITEM_TARGETTING]->setDescription(1, "SYSTEM FOR ALL");
     items[AR::ITEM_TARGETTING]->setDescription(2, "CANNONS");
     items[AR::ITEM_TARGETTING]->setDescription(3, "TARGETTING");
     items[AR::ITEM_TARGETTING]->setDescription(4, "RANGE +");
     items[AR::ITEM_TARGETTING]->setDescription(6, "MAXIMUM REACHED!");  
     items[AR::ITEM_TARGETTING]->setDescription(9, "A LASER SIGHTS HELPS YOU");
     items[AR::ITEM_TARGETTING]->setDescription(10,"TO KILL ENEMIES");
     items[AR::ITEM_TARGETTING]->setPercentage(50);

     items[AR::ITEM_CARGO]->setDescription(3, "DECAY RATE -1/SECOND");
     items[AR::ITEM_CARGO]->setDescription(4, "CARGO CAPACITY +");
     items[AR::ITEM_CARGO]->setDescription(9, "MORE IS CARGO CAPACITY");
     items[AR::ITEM_CARGO]->setDescription(10,"MORE COINS CAN BE EARNED");
     items[AR::ITEM_CARGO]->setClicks(1);
     items[AR::ITEM_CARGO]->setPercentage(8);

     items[AR::ITEM_ENEMIES_SCAN]->setDescription(0, "SHOW REMAINING");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(1, "ENEMIES");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(3, "SHOW ENEMIES");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(4, "HEALTH");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(6, "SCAN COMPLETE!");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(9, "SCAN ENEMIES TO SHOW");
     items[AR::ITEM_ENEMIES_SCAN]->setDescription(10,"USEFUL INFORMATIONS");
     items[AR::ITEM_ENEMIES_SCAN]->setEnablePercentage(false);
     items[AR::ITEM_ENEMIES_SCAN]->setMaxClicks(2);

     items[AR::ITEM_REPAIR_HULL]->setDescription(0, "REPAIR DAMAGED HULL");
     items[AR::ITEM_REPAIR_HULL]->setDescription(1, "+100 UNITS");
     items[AR::ITEM_REPAIR_HULL]->setDescription(9, "REPAIR SOME DAMAGE FOR");
     items[AR::ITEM_REPAIR_HULL]->setDescription(10,"BASE HULL");

     items[AR::ITEM_REPAIR_SHIELD]->setDescription(0, "RESTORE SHIELD");
     items[AR::ITEM_REPAIR_SHIELD]->setDescription(1, "POWER +80");
     items[AR::ITEM_REPAIR_SHIELD]->setDescription(9, "RESTORE SOME SHIELD");
     items[AR::ITEM_REPAIR_SHIELD]->setDescription(10,"POWER");

     items[AR::ITEM_CANNON_ROTATE]->setDescription(3, "CANNONS ROTATION");
     items[AR::ITEM_CANNON_ROTATE]->setDescription(4, "SPEED +");
     items[AR::ITEM_CANNON_ROTATE]->setDescription(9, "INCREASE ROTATION SPEED");
     items[AR::ITEM_CANNON_ROTATE]->setDescription(10,"FOR ALL CANNONS");
     items[AR::ITEM_CANNON_ROTATE]->setPercentage(25);
     items[AR::ITEM_CANNON_ROTATE]->setClicks(1);
     items[AR::ITEM_CANNON_ROTATE]->setMaxClicks(11);

     items[AR::ITEM_MISSILE]->setDescription(0, "ACTIVATE MISSILE");
     items[AR::ITEM_MISSILE]->setDescription(1, "LAUNCHER");
     items[AR::ITEM_MISSILE]->setDescription(3, "MISSILE RECHARGE");
     items[AR::ITEM_MISSILE]->setDescription(4, "SPEED +1");
     items[AR::ITEM_MISSILE]->setDescription(6, "MISSILE AT");
     items[AR::ITEM_MISSILE]->setDescription(7, "MAXIMUM!");
     items[AR::ITEM_MISSILE]->setDescription(9, "LAUNCH HEAVY AND FIRE AND");
     items[AR::ITEM_MISSILE]->setDescription(10,"FORGET MISSILE");
     items[AR::ITEM_MISSILE]->setEnablePercentage(false);


     for(int i=0;i<N_INVENTORY;i++) inventory[i] = AR::NO_CANNON; // No weapons in the inventory
     cannons[0]->reset();
     cannons[1]->reset();
     changeWeapon(AR::CANNON_BASIC,0); // Basic cannon for cannon 0
     changeWeapon(AR::NO_CANNON,   1); // No weapon for cannon 1

	 // Cannon related parameters
	 cannons[0]->setCurrentFrame(1);    cannons[1]->setCurrentFrame(2);
	 cannons[0]->setHullFrame(0);       cannons[1]->setHullFrame(3);
	 cannons[0]->setAimFrame(6);        cannons[1]->setAimFrame(7);
     cannons[0]->setRotationSpeed(0.2); cannons[1]->setRotationSpeed(0.2);
     cannons[0]->setX(915);             cannons[1]->setX(915);
     cannons[0]->setY(548);             cannons[1]->setY(548);

     missile_launcher->reset();
     missile_launcher->setHullFrame(13);
     missile_launcher->setWeapon(AR::NO_CANNON);
     missile_launcher->setBulletDamage(20);
     missile_launcher->setBulletFrame(15);
     missile_launcher->setReloadTime (1200);
     missile_launcher->setFriction(0.003,0.003);
     missile_launcher->setPower(1.6);
     missile_launcher->setLife(1000);
     missile_launcher->setX(x);
     missile_launcher->setY(y);

	 smoke->setAcceleration(0,0.02);
	 smoke->setCurrentFrame(2);
     smoke->setStartAlpha(140);
     smoke->setStartScale(0,0);
     smoke->setScaleStep(0.01,0.01);

	 explosion->setAcceleration(0,0);
	 explosion->setCurrentFrame(5);
	 explosion->setParticleATime(10);
	 explosion->setStartSpeed(100,100);
	 explosion->setRandomEnable(true);
	 explosion->setStartAlpha(250);
	 explosion->setAlphaStep(10);
	 explosion->setStartLife(0);
	}

   void restart()
    {
	 // Restart player
	 bullets_hit = 0;
	 for(int i=0;i<total_cannons;i++)    cannons[i]->restart();
	 for(int i=0;i<total_generators;i++) generators[i]->reset();
	 missile_launcher->restart();

     decay_count = decay_step;
     cargo = max_cargo;
	 smoke->setAcceleration(0,0.02);
	 smoke->setCurrentFrame(2);
     smoke->setStartAlpha(140);
     smoke->setStartScale(0,0);
     smoke->setScaleStep(0.01,0.01);

	 explosion->setAcceleration(0,0);
	 explosion->setCurrentFrame(5);
	 explosion->setParticleATime(10);
	 explosion->setStartSpeed(100,100);
	 explosion->setRandomEnable(true);
	 explosion->setStartAlpha(250);
	 explosion->setAlphaStep(10);
	 explosion->setStartLife(0);

	 shield->setX(x); shield->setY(y);
	}

   int totalBulletsFired()
    {
	 int total;

	 total = 0;
	 for(int i=0;i<total_cannons;i++) total+=cannons[i]->getBulletsFired();
	 total+=missile_launcher->getBulletsFired();
	 return total;
	}

   int countInventory()
    {
	 int total;
	 
	 total = 0;
	 for(int i=0;i<N_INVENTORY;i++)
      if(inventory[i] != AR::NO_CANNON) total++;
	 return total;
	}

   bool addToInventory(int weapon)
    {
	 bool added;
	 
	 added = false;
	 for(int i=0;i<N_INVENTORY;i++)
	  {
	   if(inventory[i] == AR::NO_CANNON) { inventory[i] = weapon; added = true; break; }
	  }
	 return added;
	}

   bool removeFromInventory(int index)
    {
	 if(index >= N_WEAPONS) return false;
	 if(index < 0)          return false;
	 for(int i=index;i<N_INVENTORY-1;i++) inventory[i] = inventory[i+1];
	 inventory[N_INVENTORY-1] = AR::NO_CANNON;	 
	 return true;
	}

   void activateShield(bool first_time = true)
    {
	 if(first_time)
	  {
       shield->setHealth(200);
	   shield->setMaxHealth(200);
      }
     shield->setEnable(true);
	}

   void setScrollXYP(float *scroll_x, float * scroll_y)
    {
	 Object::setScrollXYP(scroll_x,scroll_y);
	 missile_launcher->setScrollXYP(scroll_x,scroll_y);
	}

   void setSamplesP(AR_Sample **samples)
    {
	 Object::setSamplesP(samples);

	 sample_hit = new AR_Sample("",samples[0]->getAudio(),samples[7]);
	 sample_cannons = (AR_Sample ***)malloc(sizeof(AR_Sample **)*total_cannons);
	 for(int i=0;i<total_cannons;i++) sample_cannons[i] = (AR_Sample **)malloc(sizeof(AR_Sample *)*N_WEAPONS);
	 for(int i=0;i<total_cannons;i++)
	  for(int j=0;j<N_WEAPONS;j++)
	   sample_cannons[i][j] = new AR_Sample("",samples[0]->getAudio(),samples[j]);
    }

   void incBulletsHit() { bullets_hit++; }

   void incRadarRange() { radar_range += 0.1; }

   bool isShieldEnable() { return shield->getEnable(); }

   bool isRadarEnable()  { return radar_enable;        }

   void setSampleHit(AR_Sample *sample_hit) { this->sample_hit = sample_hit; }

   void setRadarEnable(bool radar_enable) { this->radar_enable = radar_enable; }

   void setShieldHealth(int v)         { shield->setHealth(v);          }

   void setShieldMaxHealth(int v)      { shield->setMaxHealth(v);       }

   void setShieldRechargeStep(int v)   { shield->setRechargeStep(v);    }

   void setShieldEnableRecharge(int v) { shield->setRechargeEnable(v);  }

   void setDecayStep(int decay_step)   { this->decay_step = decay_step; }

   void setMaxHealth(int max_health)   { this->max_health = max_health; }
   
   void setMaxCargo(int max_cargo)     { this->max_cargo = max_cargo;   }

   void setScoreP(int *score) { this->score = score; }

   void setRemainingEnemiesP(int *remaining_enemies) { this->remaining_enemies = remaining_enemies; }

   void setScanEnemiesRemaining(bool scan_enemies_remaining) { this->scan_enemies_remaining = scan_enemies_remaining; }
   
   void setScanEnemiesHealth(bool scan_enemies_health)       { this->scan_enemies_health = scan_enemies_health;       }
   
   void setScanEnemiesShields(bool scan_enemies_shields)     { this->scan_enemies_shields = scan_enemies_shields;     }

   void setHuntersP(Object **objects)    { hunters = objects;    }
   
   void setArmadillosP(Object **objects) { armadillos = objects; }
   
   void setBanditsP(Object **objects)    { bandits = objects;    }
   
   void setCruisersP(Object **objects)   { cruisers = objects;   }

   int getCurrentWeapon(int c) { return cannons[c]->getWeapon();   }

   int getShieldMaxHealth()    { return shield->getMaxHealth();    }

   int getShieldRechargeStep() { return shield->getRechargeStep(); }

   int getMaxHealth()          { return max_health;                }
   
   bool getShieldDown()        { return shield->getDown();         }

   int *getInventoryP()        { return inventory;  }

   Weapon **getWeaponsP()      { return weapons;    }
   
   Item   **getItemsP()        { return items;      }
   
   Object **getHuntersP()      { return hunters;    }
   
   Object **getArmadillosP()   { return armadillos; }

   Object **getBanditsP()      { return bandits;    }
   
   Object **getCruisersP()     { return cruisers;   }

   bool getScanEnemiesRemaining() { return scan_enemies_remaining; }
   
   bool getScanEnemiesHealth()    { return scan_enemies_health;    }
   
   bool getScanEnemiesShields()   { return scan_enemies_shields;   }

   int getCargo()              { return cargo;             }

   int getMaxCargo()           { return max_cargo;         }
   
   int getDecayStep()          { return decay_step;        }
   
   int getBulletsHit()         { return bullets_hit;       }

   int *getRemainingEnemiesP() { return remaining_enemies; }

   int *getScoreP()            { return score;             }
   
   float getRadarRange()       { return radar_range;       }

   MissileLauncher *getMissileLauncher() { return missile_launcher; }

 };
